#define UBOOT_LOAD_ADDR 0x1000000
#define SPLASH_LOAD (UBOOT_LOAD_ADDR + 0x80000)

extern void _syscall7(void (*)(void));

void move_and_boot(void)
{

	*(int *)0x40D00008 = 0;
	*(int *)0x40D00004 = 0; // Disable interrupts

	void (*new_main)(void) = (void (*)(void))(0xa1000000);

	new_main();
}


void my_main(void)
{
        int (*nav_fread)(void *, int, int) = (int (*)(void *, int, int))(0x545bf0);
        int (*nav_fopen)(char *, char *) = (int (*)(char *, char *))(0x54577c);
        int (*nav_fclose)(int) = (int (*)(int))(0x5455ac);


	int fdin = nav_fopen("b:\\u-boot.bin", "rb");
	nav_fread((int *)UBOOT_LOAD_ADDR, 0x100000, fdin);
	nav_fclose(fdin);

	fdin = nav_fopen("b:\\splash.bmp", "rb");
	if(fdin) {
		nav_fread((int *)SPLASH_LOAD, 0x100000, fdin);
		nav_fclose(fdin);
	}

	_syscall7(move_and_boot);

	// Just to make sure but we should never get here
	while(1);
}
